package info.bukova.isspst.ui.requirement;

import org.zkoss.bind.annotation.Command;
import org.zkoss.bind.annotation.NotifyChange;

import info.bukova.isspst.data.RequirementBase;
import info.bukova.isspst.data.TripRequirement;
import info.bukova.isspst.services.requirement.RequirementBaseService;
import info.bukova.isspst.ui.ListViewModel;

public class RequirementSubpage<T extends RequirementBase> extends ListViewModel<T> {
	
	private RequirementBaseService<T> reqService;


	@Override
	protected void loadLazyData(T data) {
		reqService.loadAuthItems(data);
	}
	
	@Command
	@NotifyChange("dataBean")
	public void approve() {
		reqService.approve(getDataBean());
	}

	@Override
	@NotifyChange({ "dataBean", "ableToDelete", "canApprove" })
	public void setDataBean(T data) {
		super.setDataBean(data);
	}
	
	public boolean isCanApprove() {
		if (getDataBean() != null) {
			return reqService.canApprove(getDataBean());
		}
		
		return false;
	}
	

}
